//+------------------------------------------------------------------+
//|                                             3PairHedgeProfit.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, zznbrm"
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_level1 0
#property indicator_color1 Yellow
#property indicator_color2 Orange
#property indicator_color3 Red
#property indicator_color4 White
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_style4 STYLE_SOLID

//+------------------------------------------------------------------+
//| User Inputs                                                      |
//+------------------------------------------------------------------+
extern datetime edtOpen = D'2011.03.10 17:10';
extern int      eintBars = 0;
extern string   estrId = "1";

extern string estrPair1 = "EURCHF";
extern double edblLots1 = 1.0;
extern double edblSpreadPips1 = 2.5;
extern string estrDir1 = "Buy";

extern string estrPair2 = "EURUSD";
extern double edblLots2 = 1.0;
extern double edblSpreadPips2 = 1.0;
extern string estrDir2 = "Sell";

extern string estrPair3 = "USDCHF";
extern double edblLots3 = 1.0;
extern double edblSpreadPips3 = 1.5;
extern string estrDir3 = "Sell";

//+------------------------------------------------------------------+
//| Indicator Buffers                                                |
//+------------------------------------------------------------------+
double gadblPair1[];
double gadblPair2[];
double gadblPair3[];
double gadblTotal[];

//+------------------------------------------------------------------+
//| Global Variables                                                 |
//+------------------------------------------------------------------+
bool gblnProcessed;
double gdblLotSize;
string gstrShortName;
string gastrSymbol[3];
double gadblOpenPrice[3];
double gadblTruePoint[3];
double gadblLots[3];
int    gaintDigits[3];
int    gaintDir[3];
double gadblSpread[3];

//*********************************************************************************************
//* STANDARD INDICATOR FUNCTIONS BELOW                                                        *
//*********************************************************************************************
//+------------------------------------------------------------------+
//| init()                                                           |
//+------------------------------------------------------------------+
int init()
{      
   SetIndexBuffer( 0, gadblPair1 );      
   SetIndexStyle( 0, DRAW_LINE );
   SetIndexLabel( 0, estrPair1 + " - " + estrDir1 ); 
   
   SetIndexBuffer( 1, gadblPair2 );      
   SetIndexStyle( 1, DRAW_LINE ); 
   SetIndexLabel( 1, estrPair2 + " - " + estrDir2 );
   
   SetIndexBuffer( 2, gadblPair3 );      
   SetIndexStyle( 2, DRAW_LINE );
   SetIndexLabel( 2, estrPair3 + " - " + estrDir3 );
   
   SetIndexBuffer( 3, gadblTotal );      
   SetIndexStyle( 3, DRAW_LINE ); 
   SetIndexLabel( 3, "Total" );
   
   gastrSymbol[0] = estrPair1;
   gastrSymbol[1] = estrPair2;
   gastrSymbol[2] = estrPair3;
   
   if ( estrDir1 == "Buy" ) gaintDir[0] = OP_BUY;   else   gaintDir[0] = OP_SELL;
   if ( estrDir2 == "Buy" ) gaintDir[1] = OP_BUY;   else   gaintDir[1] = OP_SELL;
   if ( estrDir3 == "Buy" ) gaintDir[2] = OP_BUY;   else   gaintDir[2] = OP_SELL;
   
   gadblSpread[0] = edblSpreadPips1;
   gadblSpread[1] = edblSpreadPips2;
   gadblSpread[2] = edblSpreadPips3;
   
   gadblLots[0] = edblLots1;
   gadblLots[1] = edblLots2;
   gadblLots[2] = edblLots3;
   
   int intShift;
   double dblPrice;
   
   for ( int inx = 0; inx < ArraySize( gastrSymbol ); inx++ )
   {
      gadblTruePoint[inx] = genTruePoint( gastrSymbol[inx] ); 
      gaintDigits[inx] = MarketInfo( gastrSymbol[inx], MODE_DIGITS );
      gadblSpread[inx] *= gadblTruePoint[inx];
      
      intShift = iBarShift( gastrSymbol[inx], Period(), edtOpen, false );
      dblPrice = iOpen( gastrSymbol[inx], Period(), intShift ); 
   
      if ( gaintDir[inx] == OP_BUY )   dblPrice += ( gadblSpread[inx] );
           
      gadblOpenPrice[inx] = NormalizeDouble( dblPrice, gaintDigits[inx] );
      Print( gastrSymbol[inx], " open price = ", DoubleToStr( gadblOpenPrice[inx], gaintDigits[inx] ) );
   }

   gstrShortName = "3PHP" + estrId;
   IndicatorShortName( gstrShortName );
   gblnProcessed = false;
   gdblLotSize = MarketInfo( gastrSymbol[0], MODE_LOTSIZE );
   IndicatorDigits( 2 );
   IndicatorBuffers( 4 );      
   return( 0 );
}

//+------------------------------------------------------------------+
//| deinit()                                                         |
//+------------------------------------------------------------------+
int deinit()
{ 
   ObjectDelete( "3PHP-VL" + estrId );
   ObjectDelete( "3PHP-HL" + estrId );
   ObjectDelete( "3PHP-P1" + estrId );
   ObjectDelete( "3PHP-P2" + estrId );
   ObjectDelete( "3PHP-P3" + estrId );
   return( 0 );
}

//+------------------------------------------------------------------+
//| start()                                                          |
//+------------------------------------------------------------------+
int start()
{   
   if ( gblnProcessed )    return( 0 );
   
   gblnProcessed = true;
   
   int intStart = iBarShift( Symbol(), Period(), edtOpen, true );
   int intEnd = intStart - eintBars;
   
   if ( intEnd < 0 || eintBars == 0 )   intEnd = 0;
      
   for ( int inx = intStart; inx >= intEnd; inx-- )
   {
      gadblPair1[inx] = calcProfit( 0, Time[inx] );
      gadblPair2[inx] = calcProfit( 1, Time[inx] );
      gadblPair3[inx] = calcProfit( 2, Time[inx] );
      gadblTotal[inx] = gadblPair1[inx] + gadblPair2[inx] + gadblPair3[inx];
      
      if ( gastrSymbol[inx] == Symbol() )
      {
         drawHL( "3PHP-HL" + estrId, gadblOpenPrice[inx], DimGray, STYLE_DOT );
      }         
   }   
   
   drawVL( "3PHP-VL" + estrId, edtOpen, DimGray, STYLE_DOT );
   
   drawLabel( "3PHP-P1" + estrId, gastrSymbol[0] + "-" + estrDir1 + "-" + DoubleToStr( gadblLots[0], 2 ), 200, 1, Yellow, 8, "Verdana" );
   drawLabel( "3PHP-P2" + estrId, gastrSymbol[1] + "-" + estrDir2 + "-" + DoubleToStr( gadblLots[1], 2 ), 320, 1, Orange, 8, "Verdana" );
   drawLabel( "3PHP-P3" + estrId, gastrSymbol[2] + "-" + estrDir3 + "-" + DoubleToStr( gadblLots[2], 2 ), 440, 1, Red, 8, "Verdana" );
   
   return( 0 );
}

//+------------------------------------------------------------------+
//| calcProfit()                                                     |
//+------------------------------------------------------------------+
double calcProfit( int inx, datetime dt )
{
   int intType = gaintDir[inx];
   double dblOpen = gadblOpenPrice[inx];
   
   int intShift = iBarShift( gastrSymbol[inx], Period(), dt );
   double dblClose = iClose( gastrSymbol[inx], Period(), intShift );   
   double dblPipValue = calcPipValue( inx, dt );
   double dblTruePoint = gadblTruePoint[inx];
   double dblDiff, dblProfit = 0.0;
   
   if ( intType == OP_BUY )        
   {   
      dblDiff = dblClose - dblOpen;
   }
   else if ( intType == OP_SELL )     
   {
      dblClose += gadblSpread[inx];
      dblDiff = dblOpen - dblClose;
   }
      
   dblProfit = dblDiff * dblPipValue * gadblLots[inx] / dblTruePoint;

   return( NormalizeDouble( dblProfit, 2 ) );
}

//+------------------------------------------------------------------+
//| calcPipValue()                                                   |
//| PV = BrokerLotSize * TruePoint * USDConv                         |
//+------------------------------------------------------------------+
double calcPipValue( int inx, datetime dt )
{
   string strPair = gastrSymbol[inx];
   string strCcy1 = StringSubstr( strPair, 0, 3 );
   string strCcy2 = StringSubstr( strPair, 3, 3 );
   string strTemp;
   double dblConv, dblPipValue;
      
   if ( strCcy2 == "JPY" )
   {
      dblConv = iClose( "USDJPY", Period(), iBarShift( "USDJPY", Period(), dt, false ) );         
      dblPipValue = ( gadblTruePoint[inx] / dblConv );
   }
   else if ( strCcy2 == "USD" )
   {
      dblPipValue = gadblTruePoint[inx];
   }
   else if ( strCcy1 == "USD" )
   {
      dblConv = iClose( strPair, Period(), iBarShift( strPair, Period(), dt, false ) );  
      dblPipValue = ( gadblTruePoint[inx] / dblConv );
   }
   else if ( strCcy2 == "AUD" || strCcy2 == "EUR" || strCcy2 == "GBP" || strCcy2 == "NZD" )
   {
      strTemp = strCcy2 + "USD";      
      dblConv = iClose( strTemp, Period(), iBarShift( strTemp, Period(), dt, false ) ); 
      dblPipValue = gadblTruePoint[inx] * dblConv;
   }    
   else if ( strCcy2 == "CAD" || strCcy2 == "CHF" )
   {
      strTemp = "USD" + strCcy2;      
      dblConv = iClose( strTemp, Period(), iBarShift( strTemp, Period(), dt, false ) );    
      dblPipValue = ( gadblTruePoint[inx] / dblConv );
   } 
      
   return( dblPipValue * gdblLotSize );
}

//+------------------------------------------------------------------+
//| genTruePoint()                                                   |
//+------------------------------------------------------------------+
double genTruePoint( string strPair="" )
{
   int intDigits;
   double dblPoint;
   
   if ( strPair == "" || strPair == Symbol() )    intDigits = Digits;
   else                                           intDigits = MarketInfo( strPair, MODE_DIGITS );
      
   // Reset point value for 5 digit brokers
   switch( intDigits )
   {
      case 5:
      case 4:     dblPoint = 0.0001;   break;
      case 3:
      case 2:     dblPoint = 0.01;     break;
      case 1:     dblPoint = 0.1;      break;
      case 0:     dblPoint = 0.0;      break;
      default:    dblPoint = 0.0001;
   }
   
   return( dblPoint );
}

//+------------------------------------------------------------------+
//| drawHL()                                                         |
//+------------------------------------------------------------------+
void drawHL( string strName, double dblPrice, color clr, int intStyle )
{      
   if ( ObjectFind( strName ) == -1 )
   {
      ObjectCreate( strName, OBJ_HLINE, 0, TimeCurrent(), dblPrice );
   } 
   else
   {
      ObjectMove( strName, 0, TimeCurrent(), dblPrice );
   } 
   
   ObjectSet( strName, OBJPROP_BACK, true );
   ObjectSet( strName, OBJPROP_STYLE, intStyle );
   ObjectSet( strName, OBJPROP_COLOR, clr );
}

//+------------------------------------------------------------------+
//| drawVL()                                                         |
//+------------------------------------------------------------------+
void drawVL( string strName, datetime dt, color clr, int intStyle )
{      
   if ( ObjectFind( strName ) == -1 )
   {
      ObjectCreate( strName, OBJ_VLINE, 0, dt, Bid );
   } 
   else
   {
      ObjectMove( strName, 0, dt, Bid );
   } 
   
   ObjectSet( strName, OBJPROP_BACK, true );
   ObjectSet( strName, OBJPROP_STYLE, intStyle );
   ObjectSet( strName, OBJPROP_COLOR, clr );
}

//+------------------------------------------------------------------+
//| drawLabel()                                                      |
//+------------------------------------------------------------------+
void drawLabel( string lblName, string data, int xc, int yc, color textColor, 
                int textSize, string fontName, int corner=0, bool bg=false )
{            
   if ( ObjectFind( lblName ) == -1 )
   {
      ObjectCreate( lblName, OBJ_LABEL, WindowFind( gstrShortName ), 0, 0 );      
   }
      
   ObjectSet( lblName, OBJPROP_XDISTANCE, xc );
   ObjectSet( lblName, OBJPROP_YDISTANCE, yc );  
   ObjectSet( lblName, OBJPROP_CORNER, corner );    
   ObjectSet( lblName, OBJPROP_BACK, bg );   
   ObjectSetText( lblName, data, textSize, fontName, textColor );
}



