//+------------------------------------------------------------------+
//|                                                  4Hr CCI Bar.mq4 |
//|                                    Copyright  2007 Steve Bowley |
//|                                          http://www.radatats.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Steve Bowley"
#property link      "http://www.radatats.com"

#property indicator_separate_window
//#property indicator_maximum 5
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue
//---- buffers
double buf4_up[];
double buf4_down[];
double buf3_up[];
double buf3_down[];

extern double Gap = 1; // Gap between the lines of bars

extern int Period_3 = PERIOD_H1;
extern int Period_4 = PERIOD_H4;

extern int cci_3    = 9;
extern int cci_4    = 9;

extern bool AutoDisplay      = false;

string shortname = "";
bool firstTime = true;

int UniqueNum = 228;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
  
   SetAutoDisplay();
   
  
   shortname = "4Hr CCI Bar";
   firstTime = true;
   
   IndicatorShortName(shortname);
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,0,3);
   SetIndexArrow(0,110);
   SetIndexBuffer(0,buf4_up);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,3);
   SetIndexArrow(1,110);
   SetIndexBuffer(1,buf4_down);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexArrow(2,110);
   SetIndexBuffer(2,buf3_up);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexArrow(3,110);
   SetIndexBuffer(3,buf3_down);
   SetIndexEmptyValue(3,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   SetAutoDisplay();
   
   shortname = "4Hr CCI Bar";
   firstTime = true;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i=0, y4h=0, y1h=0, yy;
   int limit=Bars-counted_bars;

   datetime TimeArray_4H[], TimeArray_1H[];
//----

  
   ArrayCopySeries(TimeArray_4H,MODE_TIME,Symbol(),Period_4); 
   ArrayCopySeries(TimeArray_1H,MODE_TIME,Symbol(),Period_3); 
      
   for(i=0, y4h=0,  y1h=0;i<limit;i++)
   {
      if (Time[i]<TimeArray_4H[y4h])   y4h++;
      if (Time[i]<TimeArray_1H[y1h])   y1h++;

      
      int cci_n = cci_3;
      for (int tf = 0; tf < 4; tf++)
      {
         int prd;
         switch (tf)
         {
            case 2: prd = Period_3; cci_n = cci_3;  yy = y1h;   break;
            case 3: prd = Period_4; cci_n = cci_4;  yy = y4h;   break;
         }
         
         double cci = iCCI(NULL, prd, cci_n,PRICE_TYPICAL, yy);
         double dUp = EMPTY_VALUE; //   iCustom(NULL, prd, "SuperTrend", false, 1, yy);
         double dDn = EMPTY_VALUE; //iCustom(NULL, prd, "SuperTrend", false, 0, yy);
         
         if (cci < 0) dUp = 1; else dDn = 1;
         
         switch (tf)
         {
            case 2: if (dUp == EMPTY_VALUE)  buf3_down[i]  = 1; else buf3_up[i]  = 1; break;
            case 3: if (dUp == EMPTY_VALUE)  buf4_down[i]  = 1  + Gap * 1; else buf4_up[i]  = 1 + Gap * 1; break;
         }
         if (NewBar())
         {
            string sDir = "";
            if (buf3_up[0] + buf4_up[0] == 4)
               sDir = "Up";
            if (buf3_down[0] + buf4_down[0] == 4)
               sDir = "Down";
            if (sDir != "")
            {
               PlaySound("alert1.wav");
               Print("4Hr - Direction ",sDir);
            }
         }         
         
      }


   }

   return(0);
  }
//+------------------------------------------------------------------+

string tf2txt(int tf)
{
   if (tf == PERIOD_H1)    return("H1");
   if (tf == PERIOD_H4)    return("H4");
}

void SetValues(int p3, int p4)
{
   Period_3 = p3; Period_4 = p4; 
}


void SetAutoDisplay()
{
   if (AutoDisplay)
   {
      switch (Period())
      {
         case PERIOD_M1  :  SetValues(PERIOD_H1, PERIOD_H4); break;
         case PERIOD_M5  :  SetValues(PERIOD_H1, PERIOD_H4); break;
         case PERIOD_M15 :  SetValues(PERIOD_H1, PERIOD_H4); break;
         case PERIOD_M30 :  SetValues(PERIOD_H1, PERIOD_H4); break;
         case PERIOD_H1  :  SetValues(PERIOD_H1, PERIOD_H4); break;
         case PERIOD_H4  :  SetValues(PERIOD_H1, PERIOD_H4); break;
         case PERIOD_D1  :  SetValues(PERIOD_H1, PERIOD_H4); break;
         case PERIOD_W1  :  SetValues(PERIOD_H1, PERIOD_H4); break;
         case PERIOD_MN1 :  SetValues(PERIOD_H1, PERIOD_H4); break;
      }
   }
   
}

bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}


