//+------------------------------------------------------------------+
//|                                             Cam_Pivots_Daily.mq4 |
//|                                           kris.pivo[at]gmail.com |
//|                                       Indicator for Interbank FX |
//+------------------------------------------------------------------+
#property copyright " Kris, 2008"                                 //|
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen 
#property indicator_color2 Red
#property indicator_color3 LimeGreen
#property indicator_color4 Red

//Input Params
extern string PivotStart = "22:00";
extern string PivotEnd   = "22:00";
extern string Midnight   = "00:00";

double Buffer0[]; // Cam H4
double Buffer1[]; // Cam H3
double Buffer2[]; // Cam L3
double Buffer3[]; // Cam L4

double LastHigh,LastLow,LastClose;
double CamH4, CamH3, CamL3, CamL4;

int OpenBar;
    
int init()
{  SetIndexStyle(0,DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(0,Buffer0);
   SetIndexLabel(0,"Camarilla H4");

   SetIndexStyle(1,DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(1,Buffer1);
   SetIndexLabel(1,"Camarilla H3");

   SetIndexStyle(2,DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(2,Buffer2);
   SetIndexLabel(2,"Camarilla L3");
   
   SetIndexStyle(3,DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(3,Buffer3);
   SetIndexLabel(3,"Camarilla L4");
   
   return(0); }

int deinit()
{ return(0); }

int start()
{  string BarTime="", LastBarTime="";         
   string BarDay="", LastBarDay="";
   int CloseBar;
          
   for(int i=Bars; i>=0; i--)
   {  BarTime = TimeToStr(Time[i], TIME_MINUTES);
      LastBarTime = TimeToStr(Time[i+1], TIME_MINUTES);
      BarDay = TimeToStr(Time[i],TIME_DATE);
      LastBarDay = TimeToStr(Time[i+1],TIME_DATE); 
      
      //need to handle if pivotrangestart/end is 00:00
      if ((PivotEnd == "00:00" && BarTime>=PivotEnd && BarDay>LastBarDay) || (BarTime>=PivotEnd && LastBarTime<PivotEnd))
      {  CloseBar = i + 1;
         
         if (OpenBar>0)
         {  calculatePivotRangeValues(OpenBar, CloseBar);  }  }
      
      if ((PivotStart == "00:00" && BarTime>=PivotStart && BarDay>LastBarDay) || (BarTime>=PivotStart && LastBarTime<PivotStart))
      { OpenBar = i; }
      
      if (OpenBar>0)
      { drawIndicators(i);  } }
   return(0);}
void calculatePivotRangeValues(int openBar, int closeBar)
   {
   LastHigh = High[Highest(NULL, 0, MODE_HIGH, (openBar - closeBar + 1), closeBar)];
   LastLow = Low[Lowest(NULL, 0, MODE_LOW, (openBar - closeBar + 1), closeBar)];
   LastClose = Close[closeBar];
   
   CamH4 = LastClose + (LastHigh - LastLow) * 1/2;
	CamH3 = LastClose + (LastHigh - LastLow) * 1/4;
	CamL3 = LastClose - (LastHigh - LastLow) * 1/4;
	CamL4 = LastClose - (LastHigh - LastLow) * 1/2;
   }

void drawIndicators(int curBar)
{
   Buffer0[curBar]=CamH4;
   Buffer1[curBar]=CamH3;
   Buffer2[curBar]=CamL3;
   Buffer3[curBar]=CamL4;
}
//+-----------------------------------------------------------------------------------------+
//|                                         THE END                                         |
//+-----------------------------------------------------------------------------------------+