//+------------------------------------------------------------------+
//|                                               Cam_Pivots_Mid.mq4 |
//|                                           kris.pivo[at]gmail.com |
//|                                       Indicator for Interbank FX |
//+------------------------------------------------------------------+
#property copyright " Kris, 2008"                                 //|
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 8

#property indicator_color1 C'90,90,90' // Gray
#property indicator_color2 C'90,90,90' // Gray
#property indicator_color3 C'90,90,90' // Gray
#property indicator_color4 C'90,90,90' // Gray
#property indicator_color5 C'90,90,90' // Gray
#property indicator_color6 C'90,90,90' // Gray
#property indicator_color7 C'90,90,90' // Gray
#property indicator_color8 C'90,90,90' // Gray

//Input Params
extern string PivotStart = "22:00";
extern string PivotEnd   = "22:00";
extern string Midnight   = "00:00";

double Buffer0[]; // Cam H6
double Buffer1[]; // Cam H5
double Buffer2[]; // Cam H2
double Buffer3[]; // Cam H1
double Buffer4[]; // Cam L1
double Buffer5[]; // Cam L2
double Buffer6[]; // Cam L5
double Buffer7[]; // Cam L6

double LastHigh,LastLow,LastClose;
double CamH6, CamH5, CamH2, CamH1, CamL1, CamL2, CamL5, CamL6;

int OpenBar;
    
int init()
{  SetIndexStyle(0,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(0,Buffer0);
   SetIndexLabel(0,"Camarilla H6");

   SetIndexStyle(1,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(1,Buffer1);
   SetIndexLabel(1,"Camarilla H5");

   SetIndexStyle(2,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(2,Buffer2);
   SetIndexLabel(2,"Camarilla H2");
   
   SetIndexStyle(3,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(3,Buffer3);
   SetIndexLabel(3,"Camarilla H1");
   
   SetIndexStyle(4,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(4,Buffer4);
   SetIndexLabel(4,"Camarilla L1");
   
   SetIndexStyle(5,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(5,Buffer5);
   SetIndexLabel(5,"Camarilla L2");

   SetIndexStyle(6,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(6,Buffer6);
   SetIndexLabel(6,"Camarilla L5");
   
   SetIndexStyle(7,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(7,Buffer7);
   SetIndexLabel(7,"Camarilla L6");
   
   return(0); }

int deinit()
{ return(0); }

int start()
{  string BarTime="", LastBarTime="";         
   string BarDay="",  LastBarDay="";
   int CloseBar;
          
   for(int i=Bars; i>=0; i--)
   {  BarTime = TimeToStr(Time[i], TIME_MINUTES);
      LastBarTime = TimeToStr(Time[i+1], TIME_MINUTES);
      BarDay = TimeToStr(Time[i],TIME_DATE);
      LastBarDay = TimeToStr(Time[i+1],TIME_DATE); 
      
      //need to handle if pivotrangestart/end is 00:00
      if ((PivotEnd == "00:00" && BarTime>=PivotEnd && BarDay>LastBarDay) || (BarTime>=PivotEnd && LastBarTime<PivotEnd))
      {  CloseBar = i + 1;
         
         if (OpenBar>0)
         {  calculatePivotRangeValues(OpenBar, CloseBar);  }  }
      
      if ((PivotStart == "00:00" && BarTime>=PivotStart && BarDay>LastBarDay) || (BarTime>=PivotStart && LastBarTime<PivotStart))
      { OpenBar = i; }
      
      if (OpenBar>0)
      { drawIndicators(i);  } }
   return(0);}
void calculatePivotRangeValues(int openBar, int closeBar)
{
   LastHigh = High[Highest(NULL, 0, MODE_HIGH, (openBar - closeBar + 1), closeBar)];
   LastLow = Low[Lowest(NULL, 0, MODE_LOW, (openBar - closeBar + 1), closeBar)];
   LastClose = Close[closeBar];
   
   CamH6 = LastClose + (LastHigh - LastLow);
   CamH5 = LastClose + (LastHigh - LastLow) * 3/4;
   
   CamH2 = LastClose + (LastHigh - LastLow) * 1/6;
	CamH1 = LastClose + (LastHigh - LastLow) * 1/16;
	
	CamL1 = LastClose - (LastHigh - LastLow) * 1/16;
	CamL2 = LastClose - (LastHigh - LastLow) * 1/6;
	
	CamL5 = LastClose - (LastHigh - LastLow) * 3/4;
	CamL6 = LastClose - (LastHigh - LastLow);
}

void drawIndicators(int curBar)
{
   Buffer0[curBar]=CamH6;
   Buffer1[curBar]=CamH5;
   Buffer2[curBar]=CamH2;
   Buffer3[curBar]=CamH1;
   Buffer4[curBar]=CamL1;
   Buffer5[curBar]=CamL2;
   Buffer6[curBar]=CamL5;
   Buffer7[curBar]=CamL6;
}
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//|                                       THE END                                           |
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+