//+------------------------------------------------------------------+
//|                                                Cams_Break_II.mq4 |
//|                                           kris.pivo[at]gmail.com |
//|                        Expert Advisor optimised for Interbank FX |
//| Requires two indicators to run:                                  |
//|   * Cam_Pivots_Daily.ex4                                         |
//|   * Cam_Pivots_Mid.ex4                                           |
//| Note: Designed for EUR/JPY M15                                   |
//+------------------------------------------------------------------+
#property copyright " Kris, 2008"                                 //|
//+------------------------------------------------------------------+
extern string  PivotStart = "22:00";
extern string  PivotEnd   = "22:00";
extern string  Midnight   = "00:00";

extern double  Lots           = 1;  
extern int     MaxTrades      = 1;
extern int     slippage       = 5;
extern int     MagicNumber    = 456;
extern int     buffer         = 0;

extern int     Start_time     = 0;
extern int     endtradingtime = 21;
extern int     enday          = 21;
extern int     endayfriday    = 20;


//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
int start()
{
 int numbertrades=2;
 int tradedirection=tradedirection();
 double sl,tp1,tp2,tp3;
 
 double LongPT3  = iCustom(NULL,0,"Cam_Pivots_Mid",PivotStart,PivotEnd,Midnight,0,0); // CamH6, Buffer0
 double LongPT2  = iCustom(NULL,0,"Cam_Pivots_Mid",PivotStart,PivotEnd,Midnight,1,0); // CamH5, Buffer1
 double LongPT1  = iCustom(NULL,0,"Cam_Pivots_Mid",PivotStart,PivotEnd,Midnight,1,0); // CamH5, Buffer1
 
 double LongEnt    = iCustom(NULL,0,"Cam_Pivots_Daily",PivotStart,PivotEnd,Midnight,0,0);   // CamH4, Buffer0
 double Init_StopL = iCustom(NULL,0,"Cam_Pivots_Daily",PivotStart,PivotEnd,Midnight,1,0);   // CamH3, Buffer1
 
 double Init_StopS = iCustom(NULL,0,"Cam_Pivots_Daily",PivotStart,PivotEnd,Midnight,2,0);   // CamL3, Buffer2
 double ShortEnt   = iCustom(NULL,0,"Cam_Pivots_Daily",PivotStart,PivotEnd,Midnight,3,0);   // CamL4, Buffer3
 
 double ShortPT1 = iCustom(NULL,0,"Cam_Pivots_Mid",PivotStart,PivotEnd,Midnight,6,0); // CamL5, Buffer5
 double ShortPT2 = iCustom(NULL,0,"Cam_Pivots_Mid",PivotStart,PivotEnd,Midnight,6,0); // CamL5, Buffer6
 double ShortPT3 = iCustom(NULL,0,"Cam_Pivots_Mid",PivotStart,PivotEnd,Midnight,7,0); // CamL6, Buffer7
 
 int Start_time=startime(); 

// Take care of open trades
 if(opentrades()>0)
 {
 // close at end of day
  if(endofday()>0) 
   {
   closealltrades();
   return(0);
   } 
  if(tradedirection==1) {modifystoploss(LongPT1, LongPT2, LongEnt, LongPT1); }
  if(tradedirection==0) {modifystoploss(ShortPT1,ShortPT2,ShortEnt,ShortPT1);}
  
// if market runs to the opposite side of the opening range close all trades

   if(tradedirection==1 && Close[1]<Init_StopL) {closealltrades();}  
//  if(tradedirection==1 && Close[1]<ShortEnt) {closealltrades();}   //  || Close[0]<ShortPT1)
//  if(tradedirection==1 && Close[1]<(LongEnt-(LongEnt-ShortEnt)*Init_Stop))  {closealltrades();}
   if(tradedirection==0 && Close[1]>Init_StopS) {closealltrades();}
//  if(tradedirection==0 && Close[1]>LongEnt ) {closealltrades();}    //  || Close[0]>LongPT1)
//  if(tradedirection==0 && Close[1]>(ShortEnt+(LongEnt-ShortEnt)*Init_Stop)) {closealltrades();}

  }
//+------------------------------------------------------------------+
 
 // No open trades, or not all open trades 
 if(tradingtime(Start_time)>0 && opentrades()<MaxTrades)
 {
  //Start of day
  if(Hour()==Start_time) // +1)
  {
   if(Close[2]<LongEnt && Close[1]>LongEnt && Close[0]>LongEnt && Close[0]<LongPT1)
   {
    sl=0; // use the close of other side to exit
    tp1=LongPT1;
    tp2=LongPT2;
    tp3=LongPT3; 
    
    if (opentrades()==0)
    {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);}
    if(opentrades()<=1)
    {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
    if(opentrades()<=2)
    {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
    return(0);
   }
   
   if(Close[2]>ShortEnt && Close[1]<ShortEnt && Close[0]<ShortEnt && Close[0]>ShortPT1)  // added the entry filter - above the TP1
   {
    sl=0; // use the close of other side to exit
    tp1=ShortPT1;
    tp2=ShortPT2;
    tp3=ShortPT3;
      
    if(opentrades()==0)
    {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);}
    if(opentrades()<=1)
    {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
    if(opentrades()<=2)
    {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
    return(0);
   }
  }
 }      
//+------------------------------------------------------------------+
 
 // New close above or below the Opening Range
 
 if (tradingtime(Start_time)>0 && opentrades()<MaxTrades)
  {
  if(Close[2]<LongEnt && Close[1]>LongEnt  && Close[0]>LongEnt && Close[0]<LongPT1)  // LONG Entry
   {
   sl=0; // use the close of other side to exit
   tp1=LongPT1;
   tp2=LongPT2;
   tp3=LongPT3; 
    
   if (opentrades()==0)
   {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);}
   if(opentrades()<=1)
   {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
   if(opentrades()<=2)
   {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
   return(0); }
 
  if(Close[2]>ShortEnt && Close[1]<ShortEnt && Close[0]<ShortEnt && Close[0]>ShortPT1)  // SHORT Entry
   {
   sl=0; // use the close of other side to exit
   tp1=ShortPT1;
   tp2=ShortPT2;
   tp3=ShortPT3;
      
   if(opentrades()==0)
   {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);}
   if(opentrades()<=1)
   {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
   if(opentrades()<=2)
   {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
   return(0); }
 }
 return(0); 
}
//+------------------------------------------------------------------+

int startime()
{
 int cnt, startime;
 
 for(cnt=0;cnt<24;cnt++)
 {
  if(iCustom(NULL,0,"Cam_Pivots_Daily",PivotStart,PivotEnd,Midnight,0,cnt+1)!=iCustom(NULL,0,"Cam_Pivots_Daily",PivotStart,PivotEnd,Midnight,0,cnt))
  {
   startime=Hour()-cnt;
   if (startime<0){startime=startime+24;}
   return(startime);
  }
 }
}
//-----------------------------------------------------------------

void modifystoploss(double sla1,double sla2, double sl1,double sl2)
{
  int cnt;
  double buyprice, currentsl,newsl=0;
  
  //find current buyprice and stop loss
  for(cnt=0;cnt<OrdersTotal();cnt++)   
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
      {
        buyprice=OrderOpenPrice();
        currentsl=OrderStopLoss();
      }
    }  

  //for long trades
  if(tradedirection()==1)
  {       
    if(Close[1]>= sla1) {newsl=sl1;}
    if(Close[1]>= sla2) {newsl=sl2;}
    
    if(newsl>currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
  else if(tradedirection()==0)
  {    
    if(Close[1]<= sla1) {newsl=sl1;}
    if(Close[1]<= sla2) {newsl=sl2;}
    
    if(newsl<currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),3,Blue);}   // 0
      } 
    }
  }
}
//---------------------------------------------------------------------------------

int opentrades()
{
  int trades=0;
  int cnt;
  
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);  
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) {trades ++;}
  }     
  return(trades);
}
//---------------------------------------------------------------------------------

int endofday()
{
  int dayend=0; 
  if(Hour()==enday) {dayend=1;}
  if(DayOfWeek()==5 && Hour()==endayfriday) {dayend=1;}
  return(dayend);
}

void closealltrades()
{
  int cnt;
  for(cnt=0;cnt<10;cnt++)
  {
    closetrades();
    if(opentrades()==0){cnt=10;}
  }
}  
//----------------------------------------------------------------------------------  

void closetrades()
{
  int cnt;
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {		
	 	 if(OrderType() == 1) 	
	 	 {OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow);}
	 	 else {OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow);}
	 }
  }
}
//----------------------------------------------------------------------------------

int tradedirection()
{
  int cnt;
  int direction;
  
  for(cnt=OrdersTotal();cnt>=0;cnt--)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {				
	 	 if (OrderType() == 0) {direction=1;}
	 	 if (OrderType() == 1) {direction=0;}
	 	 cnt=-1;
	 }
  }
  return (direction);
}
//-----------------------------------------------------------------------------------
 
int tradingtime(int Start_time)
{

  int trading=0;
  
  if(Start_time<endtradingtime && Hour()<endtradingtime && Hour()>Start_time) {trading=1;}
  if(Start_time>endtradingtime)
  {
    if(Hour()>Start_time && Hour()<endtradingtime){trading=1;}
  }
  return(trading);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//                                       THE END                                       |
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

